diff --git a/docs/api/IoT.js-API-I2C.md b/docs/api/IoT.js-API-I2C.md
index 1e93d5489..556f7f53c 100644
--- a/docs/api/IoT.js-API-I2C.md
+++ b/docs/api/IoT.js-API-I2C.md
@@ -5,51 +5,58 @@ The following shows I2C module APIs available for each platform.
 |  | Linux<br/>(Ubuntu) | Raspbian<br/>(Raspberry Pi) | NuttX<br/>(STM32F4-Discovery) | TizenRT<br/>(Artik053) |
 | :---: | :---: | :---: | :---: | :---: |
 | i2c.open | O | O | O | O |
+| i2c.openSync | O | O | O | O |
 | i2cbus.read | O | O | O | O |
+| i2cbus.readSync | O | O | O | O |
 | i2cbus.write | O | O | O | O |
+| i2cbus.writeSync | O | O | O | O |
 | i2cbus.close | O | O | O | O |
+| i2cbus.closeSync | O | O | O | O |
 
 
 # I2C
 
-The I2C class supports the I2C protocol. I2C bus has two signals - SDA and SCL.
+The I2C module supports the I2C protocol. I2C bus has two signals - SDA and SCL.
 
+### i2c.open(configuration[, callback])
+* `configuration` {Object} Configuration for open I2CBus.
+  * `device` {string} Device path. (only on Linux)
+  * `bus` {number} The specified bus number. (NuttX and TizenRT only)
+  * `address` {number} Device address.
+* `callback` {Function}
+  * `err` {Error|null}
+  * `i2cBus` {Object} An instance of I2CBus.
+* Returns: {Object} An instance of I2CBus.
 
-### new I2C()
-
-Returns with an I2C object.
+Get I2CBus object with configuration asynchronously.
 
 **Example**
 
 ```js
-var I2C = require('i2c');
+var i2c = require('i2c');
 
-var i2c = new I2C();
+i2c.open({device: '/dev/i2c-1', address: 0x23}, function(err, wire) {
+  if (err) {
+    throw err;
+  }
+});
 ```
 
-
-### i2c.open(configuration[, callback])
+### i2c.openSync(configuration)
 * `configuration` {Object} Configuration for open I2CBus.
-  * `device` {string(linux)|number(NuttX)} Device path.
-  * `bus` {number} The specified bus number. (TizenRT only)
+  * `device` {string} Device path. (only on Linux)
+  * `bus` {number} The specified bus number. (NuttX and TizenRT only)
   * `address` {number} Device address.
-* `callback` {Function}
-  * `err` {Error|null}
 * Returns: {Object} An instance of I2CBus.
 
-Get I2CBus object with configuration.
+Get I2CBus object with configuration synchronously.
 
 **Example**
 
 ```js
-var I2C = require('i2c');
+var i2c = require('i2c');
 
-var i2c = new I2C();
-var i2c_bus = i2c.open({device: '/dev/i2c-1', address: 0x23}, function(err) {
-  if (err) {
-    throw err;
-  }
-});
+var wire = i2c.openSync({device: '/dev/i2c-1', address: 0x23});
 ```
 
 
@@ -62,21 +69,36 @@ var i2c_bus = i2c.open({device: '/dev/i2c-1', address: 0x23}, function(err) {
   * `err` {Error|null}
   * `res` {Array} Array of bytes.
 
-Read bytes from I2C device.
+Read bytes from I2C device asynchronously.
 
 **Example**
 
 ```js
-var I2C = require('i2c');
+var i2c = require('i2c');
+
+i2c.open({device: '/dev/i2c-1', address: 0x23}, function(err, wire) {
+  wire.read(2, function(err, res) {
+    if (!err) {
+      console.log('read result: ' + res);
+    }
+  });
+});
+```
 
-var i2c = new I2C();
-var i2c_bus = i2c.open({device: '/dev/i2c-1', address: 0x23});
+### i2cbus.readSync(length)
+* `length` {number} Number of bytes to read.
+* Returns: {Array} Array of bytes.
 
-i2c_bus.read(2, function(err, res) {
-  if (!err) {
-    console.log('read result: ' + res);
-  }
-});
+Read bytes from I2C device synchronously.
+
+**Example**
+
+```js
+var i2c = require('i2c');
+
+var wire = i2c.openSync({device: '/dev/i2c-1', address: 0x23});
+var res = wire.readSync(2);
+console.log(res);
 ```
 
 ### i2cbus.write(bytes[, callback])
@@ -84,35 +106,63 @@ i2c_bus.read(2, function(err, res) {
 * `callback` {Function}
   * `err` {Error|null}
 
-Write bytes to I2C device.
+Write bytes to I2C device asynchronously.
 
 **Example**
 
 ```js
-var I2C = require('i2c');
-
-var i2c = new I2C();
-var i2c_bus = i2c.open({device: '/dev/i2c-1', address: 0x23});
-
-i2c_bus.write([0x10], function(err) {
-  if(!err) {
-    console.log('write done');
-  }
+var i2c = require('i2c');
+
+i2c.open({device: '/dev/i2c-1', address: 0x23}, function(err, wire){
+  wire.write([0x10], function(err) {
+    if(!err) {
+      console.log('write done');
+    }
+  });
 });
 ```
 
+### i2cbus.writeSync(bytes)
+* `bytes` {Array} Array of bytes to write.
+* `callback` {Function}
+  * `err` {Error|null}
+
+Write bytes to I2C device synchronously.
+
+**Example**
+
+```js
+var i2c = require('i2c');
+
+var wire = i2c.openSync({device: '/dev/i2c-1', address: 0x23});
+wire.writeSync([0x10]);
+```
 
 ### i2cbus.close()
+* `callback` {Function}
+  * `err` {Error|null}
 
-Close I2C device.
+Close I2C device asynchronously.
 
 **Example**
 
 ```js
-var I2C = require('i2c');
+var i2c = require('i2c');
 
-var i2c = new I2C();
-var i2c_bus = i2c.open({device: '/dev/i2c-1', address: 0x23});
-
-i2c_bus.close();
+i2c.open({device: '/dev/i2c-1', address: 0x23}, function(err, wire) {
+  wire.close();
+});
 ```
+
+### i2cbus.closeSync()
+
+Close I2C device synchronously.
+
+**Example**
+
+```js
+var i2c = require('i2c');
+
+var wire = i2c.openSync({device: '/dev/i2c-1', address: 0x23});
+wire.closeSync();
+```
\ No newline at end of file
diff --git a/docs/devs/Extended-API-Guidelines.md b/docs/devs/Extended-API-Guidelines.md
index 3d19c15cf..7632e29cf 100644
--- a/docs/devs/Extended-API-Guidelines.md
+++ b/docs/devs/Extended-API-Guidelines.md
@@ -5,7 +5,7 @@ However, extended APIs need a guideline because they are implemented by many con
 # Ground Rules
 
 ## API naming rules
-1. The APIs which have similar role should have same API name. 
+1. The APIs which have similar role should have same API name.
 2. Basically, all APIs are async API. If you want to make sync API, you need to add `Sync` as a suffix.<br>For example, `readSync()`, `writeSync()`, and so on.
 
 ## Generating an object 
@@ -15,22 +15,21 @@ However, extended APIs need a guideline because they are implemented by many con
 For example, GPIO module generate an object like below:
 ```javascript
 var Gpio = require('gpio');
-var gpio = new Gpio();
-var gpio10 = gpio.open({pin: 10, direction: gpio.DIRECTION.OUT},
-                       function(err){console.log(err);});
-gpio10.writeSync(1);
-
-
+var gpio10 = gpio.open({pin: 10, direction: gpio.DIRECTION.OUT},		
+                                     function(err){console.log(err);});
+gpio10.writeSync(1);                         
 ```
 
 ## Minimize event generation
 1. The response of the API call uses callback function.
 2. Only generate event when user need to know something without any API call.
-3. The event which have similar role should have same event name.
+3. The event which has similar role should have same event name.
 
 ## Error generation
 1. `error` can be generated in both JS/native side.
-2. The `error` shoud be created in the place where it occurs.
+2. The `error` should be created in the place where it occurs.
+3. In the asynchronous function, the first parameter of callback indicates an error.
+If it is null, the function works without error.
 
 For example, error can be generated like below:
 
@@ -38,9 +37,8 @@ In native side,
 ```c
 iotjs_jargs_t jargs = iotjs_jargs_create(2);
 
-// kGpioErrRead: int
-if (result == kGpioErrRead) {
-  iotjs_jargs_append_error_with_code(&jargs, "GPIO Error", kGpioErrRead);
+if (!result) {
+  iotjs_jargs_append_error(&jargs, "GPIO Error");
 }
 ```
 
@@ -58,6 +56,5 @@ if (!util.isNumber(value)) {
 
 
 # Recommended Rules
-1. Call `close()` api when process module occur `exit` event.
-2. If it is possible, use the functions provided by `libtuv` (File open, read, write, etc.)
-3. Callback function in API argument should be always optional.
+1. If it is possible, use the functions provided by `libtuv` (File open, read, write, etc.)
+2. Callback function in API argument should be always optional.
diff --git a/samples/i2c/i2c_ht16k33.js b/samples/i2c/i2c_ht16k33.js
index d7e59cdc1..6b59b5e57 100644
--- a/samples/i2c/i2c_ht16k33.js
+++ b/samples/i2c/i2c_ht16k33.js
@@ -13,11 +13,11 @@
  * limitations under the License.
  */
 
-var I2C = require('i2c');
-var i2c = new I2C();
+var i2c = require('i2c');
 
 var CMD_BRIGHTNESS = 0xE0;
 var CMD_OSCILLATOR = 0x21;
+var CMD_DISPLAY_ON = 0x81;
 
 var iotChar = [0x00, 0x00, 0x00, 0x00,
   0xCE, 0x73, 0x44, 0x22,
@@ -28,26 +28,26 @@ var writeLed = function(wire, data) {
   // 0x00 is a initial signal for writing
   var buffer = [0x00].concat(data);
   wire.write(buffer);
-}
+};
 
 var configuration = {};
 configuration.address = 0x70;
 
 if (process.platform === 'linux') {
   configuration.device = '/dev/i2c-1';
-} else if (process.platform === 'nuttx') {
-  configuration.device = 1;
+} else if (process.platform === 'nuttx' || process.platform == 'tizenrt') {
+  configuration.bus = 1;
 } else {
   throw new Error('Unsupported platform');
 }
 
-var wire = i2c.open(configuration, function(err) {
+i2c.open(configuration, function(err, wire) {
   if (err) {
     throw err;
   }
 
-  wire.write([CMD_OSCILLATOR]); // turn on oscillator
-  wire.write([CMD_BRIGHTNESS | 1]); // adjust brightness
-
+  wire.writeSync([CMD_OSCILLATOR]); // turn on oscillator
+  wire.writeSync([CMD_DISPLAY_ON]);
+  wire.writeSync([CMD_BRIGHTNESS | 1]); // adjust brightness
   writeLed(wire, iotChar);
 });
diff --git a/src/iotjs_binding.h b/src/iotjs_binding.h
index 61ac2999d..5a84b280e 100644
--- a/src/iotjs_binding.h
+++ b/src/iotjs_binding.h
@@ -208,6 +208,18 @@ jerry_value_t iotjs_jhelper_eval(const char* name, size_t name_len,
     }                                                            \
   } while (0)
 
+#define JS_GET_REQUIRED_ARG_VALUE(index, target, property, type)            \
+  do {                                                                      \
+    if (jerry_value_is_undefined(jargv[index])) {                           \
+      return JS_CREATE_ERROR(TYPE, "Missing argument, required " property); \
+    } else if (jerry_value_is_##type(jargv[index])) {                       \
+      target = iotjs_jval_as_##type(jargv[index]);                          \
+    } else {                                                                \
+      return JS_CREATE_ERROR(TYPE, "Bad arguments, required " property      \
+                                   " is not a " #type);                     \
+    }                                                                       \
+  } while (0)
+
 #define DJS_GET_REQUIRED_CONF_VALUE(src, target, property, type)            \
   do {                                                                      \
     jerry_value_t jtmp = iotjs_jval_get_property(src, property);            \
diff --git a/src/iotjs_magic_strings.h b/src/iotjs_magic_strings.h
index 990a48686..b3de3c342 100644
--- a/src/iotjs_magic_strings.h
+++ b/src/iotjs_magic_strings.h
@@ -86,6 +86,7 @@
 #define IOTJS_MAGIC_STRING_COMPARE "compare"
 #define IOTJS_MAGIC_STRING_COMPILE "compile"
 #define IOTJS_MAGIC_STRING_COMPILEMODULE "compileModule"
+#define IOTJS_MAGIC_STRING_CONFIG "config"
 #define IOTJS_MAGIC_STRING_CONNECT "connect"
 #define IOTJS_MAGIC_STRING_COPY "copy"
 #if ENABLED_MODULE(HTTPS)
@@ -94,6 +95,7 @@
 #define IOTJS_MAGIC_STRING__CREATESTAT "_createStat"
 #define IOTJS_MAGIC_STRING_CREATETCP "createTCP"
 #define IOTJS_MAGIC_STRING_CWD "cwd"
+#define IOTJS_MAGIC_STRING_DATA "data"
 #if ENABLED_MODULE(UART)
 #define IOTJS_MAGIC_STRING_DATABITS "dataBits"
 #endif
@@ -294,6 +296,7 @@
 #define IOTJS_MAGIC_STRING_VERSION "version"
 #define IOTJS_MAGIC_STRING_WRITEUINT8 "writeUInt8"
 #define IOTJS_MAGIC_STRING_WRITE "write"
+#define IOTJS_MAGIC_STRING_WRITESYNC "writeSync"
 #if ENABLED_MODULE(HTTPS)
 #define IOTJS_MAGIC_STRING__WRITE "_write"
 #endif
diff --git a/src/iotjs_reqwrap.c b/src/iotjs_reqwrap.c
index e9532ae02..2098943f6 100644
--- a/src/iotjs_reqwrap.c
+++ b/src/iotjs_reqwrap.c
@@ -20,7 +20,6 @@
 void iotjs_reqwrap_initialize(iotjs_reqwrap_t* reqwrap, jerry_value_t jcallback,
                               uv_req_t* request) {
   IOTJS_VALIDATED_STRUCT_CONSTRUCTOR(iotjs_reqwrap_t, reqwrap);
-  IOTJS_ASSERT(jerry_value_is_function(jcallback));
   _this->jcallback = jerry_acquire_value(jcallback);
   _this->request = request;
   _this->request->data = reqwrap;
diff --git a/src/iotjs_util.c b/src/iotjs_util.c
index be0e78f9f..7d88973ed 100644
--- a/src/iotjs_util.c
+++ b/src/iotjs_util.c
@@ -71,6 +71,18 @@ char* iotjs_buffer_allocate(size_t size) {
 }
 
 
+char* iotjs_buffer_allocate_from_number_array(size_t size,
+                                              const jerry_value_t array) {
+  char* buffer = iotjs_buffer_allocate(size);
+  for (uint8_t i = 0; i < size; i++) {
+    jerry_value_t jdata = iotjs_jval_get_property_by_index(array, i);
+    buffer[i] = iotjs_jval_as_number(jdata);
+    jerry_release_value(jdata);
+  }
+  return buffer;
+}
+
+
 char* iotjs_buffer_reallocate(char* buffer, size_t size) {
   IOTJS_ASSERT(buffer != NULL);
   return (char*)(realloc(buffer, size));
diff --git a/src/iotjs_util.h b/src/iotjs_util.h
index e7e18968c..14168c6a6 100644
--- a/src/iotjs_util.h
+++ b/src/iotjs_util.h
@@ -18,12 +18,14 @@
 
 
 #include "iotjs_string.h"
-
+#include "jerryscript.h"
 
 // Return value should be released with iotjs_string_destroy()
 iotjs_string_t iotjs_file_read(const char* path);
 
 char* iotjs_buffer_allocate(size_t size);
+char* iotjs_buffer_allocate_from_number_array(size_t size,
+                                              const jerry_value_t array);
 char* iotjs_buffer_reallocate(char* buffer, size_t size);
 void iotjs_buffer_release(char* buff);
 
diff --git a/src/js/i2c.js b/src/js/i2c.js
index 435929079..767462406 100644
--- a/src/js/i2c.js
+++ b/src/js/i2c.js
@@ -1,29 +1,3 @@
-/* Copyright (c) 2013, Kelly Korevec <korevec@gmail.com>
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *     * Redistributions of source code must retain the above copyright
- *       notice, this list of conditions and the following disclaimer.
- *     * Redistributions in binary form must reproduce the above copyright
- *       notice, this list of conditions and the following disclaimer in the
- *       documentation and/or other materials provided with the distribution.
- *     * Neither the name of the author nor the
- *       names of its contributors may be used to endorse or promote products
- *       derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
- * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
- * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
- * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
 /* Copyright 2016-present Samsung Electronics Co., Ltd. and other contributors
  *
  * Licensed under the Apache License, Version 2.0 (the "License");
@@ -39,106 +13,16 @@
  * limitations under the License.
  */
 
-/* This file includes all APIs in 'node-i2c'(https://github.com/kelly/node-i2c).
- * Some functions are translated from coffee script(i2c.coffee) in 'node-i2c'.
- */
-
-var util = require('util');
-
-function I2C() {
-  if (!(this instanceof I2C)) {
-    return new I2C();
-  }
-}
-
-I2C.prototype.open = function(configurable, callback) {
-  return i2cBusOpen(configurable, callback);
-};
-
-
-function i2cBusOpen(configurable, callback) {
-  var _binding = null;
-
-  function I2CBus(configurable, callback) {
-    var i2cContext;
-
-    if (util.isObject(configurable)) {
-      if (process.platform === 'linux') {
-        i2cContext = configurable.device;
-        if (!util.isString(i2cContext)) {
-          throw new TypeError('Bad configurable - device: String');
-        }
-      } else if (process.platform === 'nuttx' ||
-                 process.platform === 'tizen') {
-        i2cContext = configurable.device;
-        if (!util.isNumber(i2cContext)) {
-          throw new TypeError('Bad configurable - device: Number');
-        }
-      } else if (process.platform === 'tizenrt') {
-        i2cContext = configurable.bus;
-        if (!util.isNumber(i2cContext)) {
-          throw new TypeError('Bad configurable - bus: Number');
-        }
-      } else {
-        throw new Error('Unsupported platform');
-      }
-
-      if (!util.isNumber(configurable.address)) {
-        throw new TypeError('Bad configurable - address: Number');
-      }
-
-      this.address = configurable.address;
-
-      _binding = new native(i2cContext, (function(_this) {
-        return function(err) {
-          if (!err) {
-            _this.setAddress(configurable.address);
-          }
-          util.isFunction(callback) && callback(err);
-        };
-      })(this));
-    }
-  }
-
-  I2CBus.prototype.close = function() {
-    _binding.close();
-  };
-
-  I2CBus.prototype.setAddress = function(address, callback) {
-    if (!util.isNumber(address)) {
-      throw new TypeError('Bad argument - address: Number');
-    }
-
-    this.address = address;
-    _binding.setAddress(this.address);
-
-    util.isFunction(callback) && callback();
-  };
-
-  I2CBus.prototype.write = function(array, callback) {
-    if (!util.isArray(array)) {
-      throw new TypeError('Bad argument - array: Array');
-    }
-
-    this.setAddress(this.address);
-    _binding.write(array, function(err) {
-      util.isFunction(callback) && callback(err);
-    });
-  };
-
-  I2CBus.prototype.read = function(length, callback) {
-    if (!util.isNumber(length)) {
-      throw new TypeError('Bad argument - length: Number');
-    }
-
-    this.setAddress(this.address);
-    _binding.read(length, function(err, data) {
-      util.isFunction(callback) && callback(err, data);
+var i2c = {
+  open: function(config, callback) {
+    var i2cBus = new native(config, function(err) {
+      callback(err, i2cBus);
     });
-  };
-
-  return new I2CBus(configurable, callback);
-}
-
+    return i2cBus;
+  },
+  openSync: function(config) {
+    return new native(config);
+  },
+};
 
-module.exports = I2C;
+module.exports = i2c;
diff --git a/src/modules.json b/src/modules.json
index 928760e25..9da3be6cf 100644
--- a/src/modules.json
+++ b/src/modules.json
@@ -226,7 +226,6 @@
       "native_files": ["modules/iotjs_module_i2c.c"],
       "init": "InitI2c",
       "js_file": "js/i2c.js",
-      "require": ["util"]
     },
     "module": {
       "js_file": "js/module.js",
diff --git a/src/modules/iotjs_module_i2c.c b/src/modules/iotjs_module_i2c.c
index 5e630cd9f..6d460bdca 100644
--- a/src/modules/iotjs_module_i2c.c
+++ b/src/modules/iotjs_module_i2c.c
@@ -19,19 +19,12 @@
 #include "iotjs_objectwrap.h"
 
 
-#define THIS iotjs_i2c_reqwrap_t* i2c_reqwrap
+IOTJS_DEFINE_NATIVE_HANDLE_INFO_THIS_MODULE(i2c);
 
-static JNativeInfoType this_module_native_info = {.free_cb = NULL };
-
-static void i2c_destroy_data(iotjs_i2c_t* i2c) {
-  IOTJS_DECLARE_THIS(iotjs_i2c_t, i2c);
-  i2c_destroy_platform_data(_this->platform_data);
-}
-
-static iotjs_i2c_t* iotjs_i2c_create(void* device, const jerry_value_t ji2c) {
+static iotjs_i2c_t* iotjs_i2c_create(const jerry_value_t ji2c) {
   iotjs_i2c_t* i2c = IOTJS_ALLOC(iotjs_i2c_t);
   IOTJS_VALIDATED_STRUCT_CONSTRUCTOR(iotjs_i2c_t, i2c);
-  i2c_create_platform_data(device, i2c, &_this->platform_data);
+  i2c_create_platform_data(i2c);
   iotjs_jobjectwrap_initialize(&_this->jobjectwrap, ji2c,
                                &this_module_native_info);
   return i2c;
@@ -49,23 +42,23 @@ static iotjs_i2c_reqwrap_t* iotjs_i2c_reqwrap_create(
   return i2c_reqwrap;
 }
 
-static void iotjs_i2c_reqwrap_destroy(THIS) {
+static void iotjs_i2c_reqwrap_destroy(iotjs_i2c_reqwrap_t* i2c_reqwrap) {
   IOTJS_VALIDATED_STRUCT_DESTRUCTOR(iotjs_i2c_reqwrap_t, i2c_reqwrap);
   iotjs_reqwrap_destroy(&_this->reqwrap);
   IOTJS_RELEASE(i2c_reqwrap);
 }
 
-void iotjs_i2c_reqwrap_dispatched(THIS) {
+void iotjs_i2c_reqwrap_dispatched(iotjs_i2c_reqwrap_t* i2c_reqwrap) {
   IOTJS_VALIDATABLE_STRUCT_METHOD_VALIDATE(iotjs_i2c_reqwrap_t, i2c_reqwrap);
   iotjs_i2c_reqwrap_destroy(i2c_reqwrap);
 }
 
-uv_work_t* iotjs_i2c_reqwrap_req(THIS) {
+uv_work_t* iotjs_i2c_reqwrap_req(iotjs_i2c_reqwrap_t* i2c_reqwrap) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_reqwrap_t, i2c_reqwrap);
   return &_this->req;
 }
 
-jerry_value_t iotjs_i2c_reqwrap_jcallback(THIS) {
+jerry_value_t iotjs_i2c_reqwrap_jcallback(iotjs_i2c_reqwrap_t* i2c_reqwrap) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_reqwrap_t, i2c_reqwrap);
   return iotjs_reqwrap_jcallback(&_this->reqwrap);
 }
@@ -74,21 +67,20 @@ iotjs_i2c_reqwrap_t* iotjs_i2c_reqwrap_from_request(uv_work_t* req) {
   return (iotjs_i2c_reqwrap_t*)(iotjs_reqwrap_from_request((uv_req_t*)req));
 }
 
-iotjs_i2c_reqdata_t* iotjs_i2c_reqwrap_data(THIS) {
+iotjs_i2c_reqdata_t* iotjs_i2c_reqwrap_data(iotjs_i2c_reqwrap_t* i2c_reqwrap) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_reqwrap_t, i2c_reqwrap);
   return &_this->req_data;
 }
 
-iotjs_i2c_t* iotjs_i2c_instance_from_reqwrap(THIS) {
+iotjs_i2c_t* iotjs_i2c_instance_from_reqwrap(iotjs_i2c_reqwrap_t* i2c_reqwrap) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_reqwrap_t, i2c_reqwrap);
   return _this->i2c_data;
 }
-#undef THIS
 
 static void iotjs_i2c_destroy(iotjs_i2c_t* i2c) {
   IOTJS_VALIDATED_STRUCT_DESTRUCTOR(iotjs_i2c_t, i2c);
   iotjs_jobjectwrap_destroy(&_this->jobjectwrap);
-  i2c_destroy_data(i2c);
+  i2c_destroy_platform_data(_this->platform_data);
   IOTJS_RELEASE(i2c);
 }
 
@@ -97,61 +89,79 @@ iotjs_i2c_t* iotjs_i2c_instance_from_jval(const jerry_value_t ji2c) {
   return (iotjs_i2c_t*)jobjectwrap;
 }
 
-void AfterI2CWork(uv_work_t* work_req, int status) {
+static void i2c_worker(uv_work_t* work_req) {
+  iotjs_i2c_reqwrap_t* req_wrap = iotjs_i2c_reqwrap_from_request(work_req);
+  iotjs_i2c_reqdata_t* req_data = iotjs_i2c_reqwrap_data(req_wrap);
+  iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
+
+  switch (req_data->op) {
+    case kI2cOpOpen:
+      req_data->result = iotjs_i2c_open(i2c);
+      break;
+    case kI2cOpWrite:
+      req_data->result = iotjs_i2c_write(i2c);
+      break;
+    case kI2cOpRead:
+      req_data->result = iotjs_i2c_read(i2c);
+      break;
+    case kI2cOpClose:
+      req_data->result = iotjs_i2c_close(i2c);
+      break;
+    default:
+      IOTJS_ASSERT(!"Invalid Operation");
+  }
+}
+
+static const char* i2c_error_str(int op) {
+  switch (op) {
+    case kI2cOpOpen:
+      return "Open error, cannot open I2C";
+    case kI2cOpWrite:
+      return "Write error, cannot write I2C";
+    case kI2cOpRead:
+      return "Read error, cannot read I2C";
+    case kI2cOpClose:
+      return "Close error, cannot close I2C";
+    default:
+      return "Unknown error";
+  }
+}
+
+static void i2c_after_worker(uv_work_t* work_req, int status) {
   iotjs_i2c_reqwrap_t* req_wrap = iotjs_i2c_reqwrap_from_request(work_req);
   iotjs_i2c_reqdata_t* req_data = iotjs_i2c_reqwrap_data(req_wrap);
 
   iotjs_jargs_t jargs = iotjs_jargs_create(2);
 
   if (status) {
-    jerry_value_t error = iotjs_jval_create_error("System error");
-    iotjs_jargs_append_jval(&jargs, error);
-    jerry_release_value(error);
+    iotjs_jargs_append_error(&jargs, "System error");
   } else {
     switch (req_data->op) {
-      case kI2cOpOpen: {
-        if (req_data->error == kI2cErrOpen) {
-          jerry_value_t error =
-              iotjs_jval_create_error("Failed to open I2C device");
-          iotjs_jargs_append_jval(&jargs, error);
-          jerry_release_value(error);
-        } else {
-          iotjs_jargs_append_null(&jargs);
-        }
-        break;
-      }
-      case kI2cOpWrite: {
-        if (req_data->error == kI2cErrWrite) {
-          jerry_value_t error =
-              iotjs_jval_create_error("Cannot write to device");
-          iotjs_jargs_append_jval(&jargs, error);
-          jerry_release_value(error);
+      case kI2cOpOpen:
+      case kI2cOpWrite:
+      case kI2cOpClose: {
+        if (!req_data->result) {
+          iotjs_jargs_append_error(&jargs, i2c_error_str(req_data->op));
         } else {
           iotjs_jargs_append_null(&jargs);
         }
         break;
       }
       case kI2cOpRead: {
-        if (req_data->error == kI2cErrRead) {
-          jerry_value_t error =
-              iotjs_jval_create_error("Cannot read from device");
-          iotjs_jargs_append_jval(&jargs, error);
-          iotjs_jargs_append_null(&jargs);
-          jerry_release_value(error);
+        if (!req_data->result) {
+          iotjs_jargs_append_error(&jargs, i2c_error_str(req_data->op));
         } else {
+          iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
+          IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
+
           iotjs_jargs_append_null(&jargs);
           jerry_value_t result =
-              iotjs_jval_create_byte_array(req_data->buf_len,
-                                           req_data->buf_data);
+              iotjs_jval_create_byte_array(_this->buf_len, _this->buf_data);
           iotjs_jargs_append_jval(&jargs, result);
           jerry_release_value(result);
 
-          if (req_data->delay > 0) {
-            uv_sleep(req_data->delay);
-          }
-
-          if (req_data->buf_data != NULL) {
-            iotjs_buffer_release(req_data->buf_data);
+          if (_this->buf_data != NULL) {
+            iotjs_buffer_release(_this->buf_data);
           }
         }
         break;
@@ -164,132 +174,165 @@ void AfterI2CWork(uv_work_t* work_req, int status) {
   }
 
   const jerry_value_t jcallback = iotjs_i2c_reqwrap_jcallback(req_wrap);
-  iotjs_make_callback(jcallback, jerry_create_undefined(), &jargs);
+  if (jerry_value_is_function(jcallback)) {
+    iotjs_make_callback(jcallback, jerry_create_undefined(), &jargs);
+  }
 
   iotjs_jargs_destroy(&jargs);
   iotjs_i2c_reqwrap_dispatched(req_wrap);
 }
 
-static void GetI2cArray(const jerry_value_t jarray,
-                        iotjs_i2c_reqdata_t* req_data) {
-  // FIXME
-  // Need to implement a function to get array info from jerry_value_t Array.
-  jerry_value_t jlength =
-      iotjs_jval_get_property(jarray, IOTJS_MAGIC_STRING_LENGTH);
-  IOTJS_ASSERT(!jerry_value_is_undefined(jlength));
-
-  req_data->buf_len = iotjs_jval_as_number(jlength);
-  req_data->buf_data = iotjs_buffer_allocate(req_data->buf_len);
-
-  for (uint8_t i = 0; i < req_data->buf_len; i++) {
-    jerry_value_t jdata = iotjs_jval_get_property_by_index(jarray, i);
-    req_data->buf_data[i] = iotjs_jval_as_number(jdata);
-    jerry_release_value(jdata);
-  }
-
-  jerry_release_value(jlength);
-}
-
-#define I2C_ASYNC(op)                                                  \
+#define I2C_CALL_ASNCY(op, jcallback)                                  \
   do {                                                                 \
     uv_loop_t* loop = iotjs_environment_loop(iotjs_environment_get()); \
+    iotjs_i2c_reqwrap_t* req_wrap =                                    \
+        iotjs_i2c_reqwrap_create(jcallback, i2c, op);                  \
     uv_work_t* req = iotjs_i2c_reqwrap_req(req_wrap);                  \
-    uv_queue_work(loop, req, op##Worker, AfterI2CWork);                \
+    uv_queue_work(loop, req, i2c_worker, i2c_after_worker);            \
   } while (0)
 
 JS_FUNCTION(I2cCons) {
   DJS_CHECK_THIS();
+  DJS_CHECK_ARGS(1, object);
+  DJS_CHECK_ARG_IF_EXIST(1, function);
+
   // Create I2C object
   const jerry_value_t ji2c = JS_GET_THIS();
-#ifdef __linux__
-  DJS_CHECK_ARGS(2, string, function);
-  iotjs_string_t device = JS_GET_ARG(0, string);
-#else
-  DJS_CHECK_ARGS(2, number, function);
-  int device = JS_GET_ARG(0, number);
-#endif
-  iotjs_i2c_t* i2c = iotjs_i2c_create(&device, ji2c);
+  iotjs_i2c_t* i2c = iotjs_i2c_create(ji2c);
+  IOTJS_ASSERT(i2c == iotjs_i2c_instance_from_jval(ji2c));
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
+
+  jerry_value_t jconfig;
+  JS_GET_REQUIRED_ARG_VALUE(0, jconfig, IOTJS_MAGIC_STRING_CONFIG, object);
 
-  IOTJS_ASSERT(i2c ==
-               (iotjs_i2c_t*)(iotjs_jval_get_object_native_handle(ji2c)));
+  jerry_value_t res = iotjs_i2c_set_platform_config(i2c, jconfig);
+  if (jerry_value_has_error_flag(res)) {
+    return res;
+  }
+
+  DJS_GET_REQUIRED_CONF_VALUE(jconfig, _this->address,
+                              IOTJS_MAGIC_STRING_ADDRESS, number);
 
-  // Create I2C request wrap
-  const jerry_value_t jcallback = JS_GET_ARG(1, function);
-  iotjs_i2c_reqwrap_t* req_wrap =
-      iotjs_i2c_reqwrap_create(jcallback, i2c, kI2cOpOpen);
+  jerry_value_t jcallback = JS_GET_ARG_IF_EXIST(1, function);
 
-  I2C_ASYNC(Open);
+  // If the callback doesn't exist, it is completed synchronously.
+  // Otherwise, it will be executed asynchronously.
+  if (jerry_value_is_null(jcallback)) {
+    if (!iotjs_i2c_open(i2c)) {
+      return JS_CREATE_ERROR(COMMON, "I2C Error: cannot open I2C");
+    }
+  } else {
+    I2C_CALL_ASNCY(kI2cOpOpen, jcallback);
+  }
 
   return jerry_create_undefined();
 }
 
-JS_FUNCTION(SetAddress) {
+JS_FUNCTION(Close) {
   JS_DECLARE_THIS_PTR(i2c, i2c);
-  DJS_CHECK_ARGS(1, number);
+  DJS_CHECK_ARG_IF_EXIST(1, function);
 
-  I2cSetAddress(i2c, JS_GET_ARG(0, number));
+  I2C_CALL_ASNCY(kI2cOpClose, JS_GET_ARG_IF_EXIST(0, function));
 
-  return jerry_create_null();
+  return jerry_create_undefined();
 }
 
-JS_FUNCTION(Close) {
+JS_FUNCTION(CloseSync) {
   JS_DECLARE_THIS_PTR(i2c, i2c);
 
-  I2cClose(i2c);
-  iotjs_i2c_destroy(i2c);
+  if (!iotjs_i2c_close(i2c)) {
+    return JS_CREATE_ERROR(COMMON, "I2C Error: cannot close");
+  }
 
-  return jerry_create_null();
+  return jerry_create_undefined();
 }
 
-JS_FUNCTION(Write) {
-  JS_DECLARE_THIS_PTR(i2c, i2c);
-  DJS_CHECK_ARGS(2, array, function);
+static jerry_value_t i2c_write(iotjs_i2c_t* i2c, const jerry_value_t jargv[],
+                               const jerry_length_t jargc, bool async) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
 
-  const jerry_value_t jcallback = JS_GET_ARG(1, function);
+  jerry_value_t jarray;
+  JS_GET_REQUIRED_ARG_VALUE(0, jarray, IOTJS_MAGIC_STRING_DATA, array);
 
-  iotjs_i2c_reqwrap_t* req_wrap =
-      iotjs_i2c_reqwrap_create(jcallback, i2c, kI2cOpWrite);
-  iotjs_i2c_reqdata_t* req_data = iotjs_i2c_reqwrap_data(req_wrap);
+  // Set buffer length and data from jarray
+  _this->buf_len = jerry_get_array_length(jarray);
+  _this->buf_data =
+      iotjs_buffer_allocate_from_number_array(_this->buf_len, jarray);
 
-  GetI2cArray(JS_GET_ARG(0, array), req_data);
+  if (async) {
+    I2C_CALL_ASNCY(kI2cOpWrite, JS_GET_ARG_IF_EXIST(1, function));
+  } else {
+    if (!iotjs_i2c_write(i2c)) {
+      return JS_CREATE_ERROR(COMMON, "I2C Error: writeSync");
+    }
+  }
 
-  I2C_ASYNC(Write);
+  return jerry_create_undefined();
+}
 
-  return jerry_create_null();
+JS_FUNCTION(Write) {
+  JS_DECLARE_THIS_PTR(i2c, i2c);
+  DJS_CHECK_ARGS(1, array);
+  DJS_CHECK_ARG_IF_EXIST(1, function);
+
+  return i2c_write(i2c, jargv, jargc, true);
+}
+
+JS_FUNCTION(WriteSync) {
+  JS_DECLARE_THIS_PTR(i2c, i2c);
+  DJS_CHECK_ARGS(1, array);
+
+  return i2c_write(i2c, jargv, jargc, false);
 }
 
 JS_FUNCTION(Read) {
   JS_DECLARE_THIS_PTR(i2c, i2c);
-  DJS_CHECK_ARGS(2, number, function);
+  DJS_CHECK_ARGS(1, number);
+  DJS_CHECK_ARG_IF_EXIST(1, function);
 
-  const jerry_value_t jcallback = JS_GET_ARG(1, function);
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
 
-  iotjs_i2c_reqwrap_t* req_wrap =
-      iotjs_i2c_reqwrap_create(jcallback, i2c, kI2cOpRead);
+  JS_GET_REQUIRED_ARG_VALUE(0, _this->buf_len, IOTJS_MAGIC_STRING_LENGTH,
+                            number);
 
-  iotjs_i2c_reqdata_t* req_data = iotjs_i2c_reqwrap_data(req_wrap);
-  req_data->buf_len = JS_GET_ARG(0, number);
-  req_data->delay = 0;
+  jerry_value_t jcallback = JS_GET_ARG_IF_EXIST(1, function);
+  I2C_CALL_ASNCY(kI2cOpRead, jcallback);
+
+  return jerry_create_undefined();
+}
+
+JS_FUNCTION(ReadSync) {
+  JS_DECLARE_THIS_PTR(i2c, i2c);
+  DJS_CHECK_ARGS(1, number);
+
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
 
-  I2C_ASYNC(Read);
+  JS_GET_REQUIRED_ARG_VALUE(0, _this->buf_len, IOTJS_MAGIC_STRING_LENGTH,
+                            number);
+
+  if (!iotjs_i2c_read(i2c)) {
+    return JS_CREATE_ERROR(COMMON, "I2C Error: readSync");
+  }
 
-  return jerry_create_null();
+  return iotjs_jval_create_byte_array(_this->buf_len, _this->buf_data);
 }
 
 jerry_value_t InitI2c() {
-  jerry_value_t jI2cCons = jerry_create_external_function(I2cCons);
+  jerry_value_t ji2c_cons = jerry_create_external_function(I2cCons);
 
   jerry_value_t prototype = jerry_create_object();
 
-  iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_SETADDRESS, SetAddress);
   iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_CLOSE, Close);
+  iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_CLOSESYNC, CloseSync);
   iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_WRITE, Write);
+  iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_WRITESYNC, WriteSync);
   iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_READ, Read);
+  iotjs_jval_set_method(prototype, IOTJS_MAGIC_STRING_READSYNC, ReadSync);
 
-  iotjs_jval_set_property_jval(jI2cCons, IOTJS_MAGIC_STRING_PROTOTYPE,
+  iotjs_jval_set_property_jval(ji2c_cons, IOTJS_MAGIC_STRING_PROTOTYPE,
                                prototype);
 
   jerry_release_value(prototype);
 
-  return jI2cCons;
+  return ji2c_cons;
 }
diff --git a/src/modules/iotjs_module_i2c.h b/src/modules/iotjs_module_i2c.h
index c3e86ecfc..4acc420af 100644
--- a/src/modules/iotjs_module_i2c.h
+++ b/src/modules/iotjs_module_i2c.h
@@ -22,29 +22,16 @@
 #include "iotjs_reqwrap.h"
 
 typedef enum {
-  kI2cOpSetAddress,
   kI2cOpOpen,
   kI2cOpClose,
   kI2cOpWrite,
   kI2cOpRead,
 } I2cOp;
 
-typedef enum {
-  kI2cErrOk = 0,
-  kI2cErrOpen = -1,
-  kI2cErrRead = -2,
-  kI2cErrWrite = -3,
-} I2cError;
 
 typedef struct {
-  char* buf_data;
-  uint8_t buf_len;
-  uint8_t byte;
-  uint8_t cmd;
-  int32_t delay;
-
   I2cOp op;
-  I2cError error;
+  bool result;
 } iotjs_i2c_reqdata_t;
 
 // Forward declaration of platform data. These are only used by platform code.
@@ -54,6 +41,12 @@ typedef struct iotjs_i2c_platform_data_s iotjs_i2c_platform_data_t;
 typedef struct {
   iotjs_jobjectwrap_t jobjectwrap;
   iotjs_i2c_platform_data_t* platform_data;
+
+  char* buf_data;
+  uint8_t buf_len;
+  uint8_t byte;
+  uint8_t cmd;
+  uint8_t address;
 } IOTJS_VALIDATED_STRUCT(iotjs_i2c_t);
 
 typedef struct {
@@ -74,16 +67,17 @@ iotjs_i2c_reqdata_t* iotjs_i2c_reqwrap_data(THIS);
 iotjs_i2c_t* iotjs_i2c_instance_from_reqwrap(THIS);
 #undef THIS
 
-void I2cSetAddress(iotjs_i2c_t* i2c, uint8_t address);
-void OpenWorker(uv_work_t* work_req);
-void I2cClose(iotjs_i2c_t* i2c);
-void WriteWorker(uv_work_t* work_req);
-void ReadWorker(uv_work_t* work_req);
+
+jerry_value_t iotjs_i2c_set_platform_config(iotjs_i2c_t* i2c,
+                                            const jerry_value_t jconfig);
+bool iotjs_i2c_open(iotjs_i2c_t* i2c);
+bool iotjs_i2c_write(iotjs_i2c_t* i2c);
+bool iotjs_i2c_read(iotjs_i2c_t* i2c);
+bool iotjs_i2c_close(iotjs_i2c_t* i2c);
 
 // Platform-related functions; they are implemented
 // by platform code (i.e.: linux, nuttx, tizen).
-void i2c_create_platform_data(void* device, iotjs_i2c_t* i2c,
-                              iotjs_i2c_platform_data_t** ppdata);
+void i2c_create_platform_data(iotjs_i2c_t* i2c);
 void i2c_destroy_platform_data(iotjs_i2c_platform_data_t* platform_data);
 
 #endif /* IOTJS_MODULE_I2C_H */
diff --git a/src/modules/linux/iotjs_module_i2c-linux.c b/src/modules/linux/iotjs_module_i2c-linux.c
index 252f44452..fc7b6279c 100644
--- a/src/modules/linux/iotjs_module_i2c-linux.c
+++ b/src/modules/linux/iotjs_module_i2c-linux.c
@@ -60,28 +60,16 @@
 
 #define I2C_SLAVE_FORCE 0x0706
 
-
-#define I2C_WORKER_INIT_TEMPLATE                                            \
-  iotjs_i2c_reqwrap_t* req_wrap = iotjs_i2c_reqwrap_from_request(work_req); \
-  iotjs_i2c_reqdata_t* req_data = iotjs_i2c_reqwrap_data(req_wrap);
-
-#define IOTJS_I2C_METHOD_HEADER(arg)              \
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, arg) \
-  iotjs_i2c_platform_data_t* platform_data = _this->platform_data;
-
 struct iotjs_i2c_platform_data_s {
   iotjs_string_t device;
   int device_fd;
   uint8_t addr;
 };
 
-void i2c_create_platform_data(void* device, iotjs_i2c_t* i2c,
-                              iotjs_i2c_platform_data_t** ppdata) {
-  iotjs_i2c_platform_data_t* pdata = IOTJS_ALLOC(iotjs_i2c_platform_data_t);
-
-  pdata->device = *((iotjs_string_t*)device);
-  pdata->device_fd = -1;
-  *ppdata = pdata;
+void i2c_create_platform_data(iotjs_i2c_t* i2c) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
+  _this->platform_data = IOTJS_ALLOC(iotjs_i2c_platform_data_t);
+  _this->platform_data->device_fd = -1;
 }
 
 void i2c_destroy_platform_data(iotjs_i2c_platform_data_t* pdata) {
@@ -89,62 +77,79 @@ void i2c_destroy_platform_data(iotjs_i2c_platform_data_t* pdata) {
   IOTJS_RELEASE(pdata);
 }
 
-void I2cSetAddress(iotjs_i2c_t* i2c, uint8_t address) {
-  IOTJS_I2C_METHOD_HEADER(i2c);
-  platform_data->addr = address;
-  ioctl(platform_data->device_fd, I2C_SLAVE_FORCE, platform_data->addr);
+jerry_value_t iotjs_i2c_set_platform_config(iotjs_i2c_t* i2c,
+                                            const jerry_value_t jconfig) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
+  iotjs_i2c_platform_data_t* platform_data = _this->platform_data;
+
+  DJS_GET_REQUIRED_CONF_VALUE(jconfig, platform_data->device,
+                              IOTJS_MAGIC_STRING_DEVICE, string);
+
+  return jerry_create_undefined();
 }
 
-void OpenWorker(uv_work_t* work_req) {
-  I2C_WORKER_INIT_TEMPLATE;
-  iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
-  IOTJS_I2C_METHOD_HEADER(i2c);
+
+#define I2C_METHOD_HEADER(arg)                                     \
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, arg)                  \
+  iotjs_i2c_platform_data_t* platform_data = _this->platform_data; \
+  IOTJS_ASSERT(platform_data);                                     \
+  if (platform_data->device_fd < 0) {                              \
+    DLOG("%s: I2C is not opened", __func__);                       \
+    return false;                                                  \
+  }
+
+bool iotjs_i2c_open(iotjs_i2c_t* i2c) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
+  iotjs_i2c_platform_data_t* platform_data = _this->platform_data;
 
   platform_data->device_fd =
       open(iotjs_string_data(&platform_data->device), O_RDWR);
 
   if (platform_data->device_fd == -1) {
-    req_data->error = kI2cErrOpen;
-  } else {
-    req_data->error = kI2cErrOk;
+    DLOG("%s : cannot open", __func__);
+    return false;
+  }
+
+  if (ioctl(platform_data->device_fd, I2C_SLAVE_FORCE, _this->address) < 0) {
+    DLOG("%s : cannot set address", __func__);
+    return false;
   }
+
+  return true;
 }
 
-void I2cClose(iotjs_i2c_t* i2c) {
-  IOTJS_I2C_METHOD_HEADER(i2c);
+bool iotjs_i2c_close(iotjs_i2c_t* i2c) {
+  I2C_METHOD_HEADER(i2c);
 
-  if (platform_data->device_fd >= 0) {
-    close(platform_data->device_fd);
-    platform_data->device_fd = -1;
+  if (close(platform_data->device_fd) < 0) {
+    DLOG("%s : cannot close", __func__);
+    return false;
   }
+  
+  platform_data->device_fd = -1;
+  
+  return true;
 }
 
-void WriteWorker(uv_work_t* work_req) {
-  I2C_WORKER_INIT_TEMPLATE;
-  iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
-  IOTJS_I2C_METHOD_HEADER(i2c);
+bool iotjs_i2c_write(iotjs_i2c_t* i2c) {
+  I2C_METHOD_HEADER(i2c);
 
-  uint8_t len = req_data->buf_len;
-  char* data = req_data->buf_data;
+  uint8_t len = _this->buf_len;
+  char* data = _this->buf_data;
 
-  if (write(platform_data->device_fd, data, len) != len) {
-    req_data->error = kI2cErrWrite;
+  int ret = write(platform_data->device_fd, data, len);
+  if (_this->buf_data != NULL) {
+    iotjs_buffer_release(_this->buf_data);
   }
 
-  if (req_data->buf_data != NULL) {
-    iotjs_buffer_release(req_data->buf_data);
-  }
+  return ret == len;
 }
 
-void ReadWorker(uv_work_t* work_req) {
-  I2C_WORKER_INIT_TEMPLATE;
-  iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
-  IOTJS_I2C_METHOD_HEADER(i2c);
+bool iotjs_i2c_read(iotjs_i2c_t* i2c) {
+  I2C_METHOD_HEADER(i2c);
 
-  uint8_t len = req_data->buf_len;
-  req_data->buf_data = iotjs_buffer_allocate(len);
+  uint8_t len = _this->buf_len;
+  _this->buf_data = iotjs_buffer_allocate(len);
 
-  if (read(platform_data->device_fd, req_data->buf_data, len) != len) {
-    req_data->error = kI2cErrRead;
-  }
+  return read(platform_data->device_fd, _this->buf_data, len) == len;
 }
diff --git a/src/modules/nuttx/iotjs_module_i2c-nuttx.c b/src/modules/nuttx/iotjs_module_i2c-nuttx.c
index c51e489e4..aa224c6dd 100644
--- a/src/modules/nuttx/iotjs_module_i2c-nuttx.c
+++ b/src/modules/nuttx/iotjs_module_i2c-nuttx.c
@@ -25,105 +25,110 @@
 
 
 #define I2C_DEFAULT_FREQUENCY 400000
+#define I2C_DEFAULT_ADDRESS_LENGTH 7
 
 struct iotjs_i2c_platform_data_s {
-  int device;
+  int bus;
   struct i2c_master_s* i2c_master;
   struct i2c_config_s config;
 };
 
-void i2c_create_platform_data(void* device, iotjs_i2c_t* i2c,
-                              iotjs_i2c_platform_data_t** ppdata) {
-  iotjs_i2c_platform_data_t* pdata = IOTJS_ALLOC(iotjs_i2c_platform_data_t);
+void i2c_create_platform_data(iotjs_i2c_t* i2c) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
 
-  pdata->device = *(int*)device;
-  pdata->i2c_master = NULL;
-  *ppdata = pdata;
+  _this->platform_data = IOTJS_ALLOC(iotjs_i2c_platform_data_t);
+
+  _this->platform_data->i2c_master = NULL;
 }
 
 void i2c_destroy_platform_data(iotjs_i2c_platform_data_t* pdata) {
   IOTJS_RELEASE(pdata);
 }
 
-#define I2C_WORKER_INIT_TEMPLATE                                            \
-  iotjs_i2c_reqwrap_t* req_wrap = iotjs_i2c_reqwrap_from_request(work_req); \
-  iotjs_i2c_reqdata_t* req_data = iotjs_i2c_reqwrap_data(req_wrap);
-
-#define IOTJS_I2C_METHOD_HEADER(arg)              \
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, arg) \
+jerry_value_t iotjs_i2c_set_platform_config(iotjs_i2c_t* i2c,
+                                            const jerry_value_t jconfig) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
   iotjs_i2c_platform_data_t* platform_data = _this->platform_data;
 
+  DJS_GET_REQUIRED_CONF_VALUE(jconfig, platform_data->bus,
+                              IOTJS_MAGIC_STRING_BUS, number);
 
-void I2cSetAddress(iotjs_i2c_t* i2c, uint8_t address) {
-  IOTJS_I2C_METHOD_HEADER(i2c);
-  platform_data->config.address = address;
-  platform_data->config.addrlen = 7;
+  return jerry_create_undefined();
 }
 
-void OpenWorker(uv_work_t* work_req) {
-  I2C_WORKER_INIT_TEMPLATE;
-  iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
+#define I2C_METHOD_HEADER(arg)                                     \
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, arg)                  \
+  iotjs_i2c_platform_data_t* platform_data = _this->platform_data; \
+  IOTJS_ASSERT(platform_data);                                     \
+  if (!platform_data->i2c_master) {                                \
+    DLOG("%s: I2C is not opened", __func__);                       \
+    return false;                                                  \
+  }
+
+bool iotjs_i2c_open(iotjs_i2c_t* i2c) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c)
+  iotjs_i2c_platform_data_t* platform_data = _this->platform_data;
+  IOTJS_ASSERT(platform_data);
+
+  platform_data->config.address = _this->address;
+  platform_data->config.addrlen = I2C_DEFAULT_ADDRESS_LENGTH;
 
-  IOTJS_I2C_METHOD_HEADER(i2c);
-  platform_data->i2c_master = iotjs_i2c_config_nuttx(platform_data->device);
+  platform_data->i2c_master = iotjs_i2c_config_nuttx(platform_data->bus);
   if (!platform_data->i2c_master) {
-    DLOG("I2C OpenWorker : cannot open");
-    req_data->error = kI2cErrOpen;
-    return;
+    DLOG("%s : cannot open", __func__);
+    return false;
   }
 
   platform_data->config.frequency = I2C_DEFAULT_FREQUENCY;
 
-  req_data->error = kI2cErrOk;
+  return true;
 }
 
-void I2cClose(iotjs_i2c_t* i2c) {
-  IOTJS_I2C_METHOD_HEADER(i2c);
-  iotjs_i2c_unconfig_nuttx(platform_data->i2c_master);
-}
+bool iotjs_i2c_close(iotjs_i2c_t* i2c) {
+  I2C_METHOD_HEADER(i2c);
 
-void WriteWorker(uv_work_t* work_req) {
-  I2C_WORKER_INIT_TEMPLATE;
-  iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
-  IOTJS_I2C_METHOD_HEADER(i2c);
+  if (iotjs_i2c_unconfig_nuttx(platform_data->i2c_master) < 0) {
+    DLOG("%s : cannot close", __func__);
+    return false;
+  }
 
-  uint8_t len = req_data->buf_len;
-  uint8_t* data = (uint8_t*)req_data->buf_data;
+  return true;
+}
+
+bool iotjs_i2c_write(iotjs_i2c_t* i2c) {
+  I2C_METHOD_HEADER(i2c);
 
-  IOTJS_ASSERT(platform_data->i2c_master);
+  uint8_t len = _this->buf_len;
+  uint8_t* data = (uint8_t*)_this->buf_data;
   IOTJS_ASSERT(len > 0);
 
   int ret =
       i2c_write(platform_data->i2c_master, &platform_data->config, data, len);
-  if (ret < 0) {
-    DLOG("I2C WriteWorker : cannot write - %d", ret);
-    req_data->error = kI2cErrWrite;
-  } else {
-    req_data->error = kI2cErrOk;
+
+  if (_this->buf_data != NULL) {
+    iotjs_buffer_release(_this->buf_data);
   }
 
-  if (req_data->buf_data != NULL) {
-    iotjs_buffer_release(req_data->buf_data);
+  if (ret < 0) {
+    DLOG("%s : cannot write - %d", __func__, ret);
+    return false;
   }
+  return true;
 }
 
-void ReadWorker(uv_work_t* work_req) {
-  I2C_WORKER_INIT_TEMPLATE;
-  iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
-  IOTJS_I2C_METHOD_HEADER(i2c);
-
-  uint8_t len = req_data->buf_len;
-  req_data->buf_data = iotjs_buffer_allocate(len);
+bool iotjs_i2c_read(iotjs_i2c_t* i2c) {
+  I2C_METHOD_HEADER(i2c);
 
-  IOTJS_ASSERT(platform_data->i2c_master);
+  uint8_t len = _this->buf_len;
+  _this->buf_data = iotjs_buffer_allocate(len);
   IOTJS_ASSERT(len > 0);
 
   int ret = i2c_read(platform_data->i2c_master, &platform_data->config,
-                     (uint8_t*)req_data->buf_data, len);
+                     (uint8_t*)_this->buf_data, len);
   if (ret != 0) {
-    DLOG("I2C ReadWorker : cannot read - %d", ret);
-    req_data->error = kI2cErrRead;
-    return;
+    DLOG("%s : cannot read - %d", __func__, ret);
+    return false;
   }
-  req_data->error = kI2cErrOk;
+
+  return true;
 }
diff --git a/src/modules/tizen/iotjs_module_i2c-tizen.c b/src/modules/tizen/iotjs_module_i2c-tizen.c
deleted file mode 100644
index d781edf08..000000000
--- a/src/modules/tizen/iotjs_module_i2c-tizen.c
+++ /dev/null
@@ -1,119 +0,0 @@
-/* Copyright 2017-present Samsung Electronics Co., Ltd. and other contributors
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-#include "modules/iotjs_module_i2c.h"
-#include <peripheral_io.h>
-#include <stdint.h>
-
-
-#define I2C_WORKER_INIT_TEMPLATE                                            \
-  iotjs_i2c_reqwrap_t* req_wrap = iotjs_i2c_reqwrap_from_request(work_req); \
-  iotjs_i2c_reqdata_t* req_data = iotjs_i2c_reqwrap_data(req_wrap);
-
-#define IOTJS_I2C_METHOD_HEADER(arg)              \
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, arg) \
-  iotjs_i2c_platform_data_t* platform_data = _this->platform_data;
-
-typedef struct _peripheral_i2c_s* peripheral_i2c_h;
-
-struct iotjs_i2c_platform_data_s {
-  int bus;
-  int address;
-  peripheral_i2c_h handle;
-};
-
-void i2c_create_platform_data(void* device, iotjs_i2c_t* i2c,
-                              iotjs_i2c_platform_data_t** ppdata) {
-  iotjs_i2c_platform_data_t* pdata = IOTJS_ALLOC(iotjs_i2c_platform_data_t);
-
-  // TODO: consider allowing one step init: new I2C.open(bus, address, callback)
-  // as opposed to current new I2C.open(bus, callback)
-  pdata->bus = *(int*)device;
-
-  pdata->address = -1;
-  pdata->handle = NULL;
-  // Note: address still unset, presumably will be
-  // done by callback invoked by AfterI2CWork.
-  *ppdata = pdata;
-}
-
-void i2c_destroy_platform_data(iotjs_i2c_platform_data_t* pdata) {
-  (void)pdata;
-}
-
-// The address can be set just once.
-void I2cSetAddress(iotjs_i2c_t* i2c, uint8_t address) {
-  IOTJS_I2C_METHOD_HEADER(i2c);
-
-  if (platform_data->address == -1) {
-    // Perform delayed construction.
-    platform_data->address = address;
-    if (peripheral_i2c_open(platform_data->bus, platform_data->address,
-                            &platform_data->handle) < 0) {
-      // TODO: report the error at this point
-    }
-  } else if (platform_data->address != address) {
-    // TODO: report error OR recreate the object with new slave address
-  }
-}
-
-void OpenWorker(uv_work_t* work_req) {
-  I2C_WORKER_INIT_TEMPLATE;
-  // Tizen does not allow to control the master, just individual devices.
-  // Because of this, construction is delayed until the address is known.
-  req_data->error = kI2cErrOk;
-}
-
-void I2cClose(iotjs_i2c_t* i2c) {
-  IOTJS_I2C_METHOD_HEADER(i2c);
-
-  if (platform_data->handle != NULL) {
-    peripheral_i2c_close(platform_data->handle);
-    platform_data->handle = NULL;
-  }
-}
-
-void WriteWorker(uv_work_t* work_req) {
-  I2C_WORKER_INIT_TEMPLATE;
-  iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
-  IOTJS_I2C_METHOD_HEADER(i2c);
-
-  req_data->error = kI2cErrOk;
-  if (peripheral_i2c_write(platform_data->handle,
-                           (unsigned char*)req_data->buf_data,
-                           req_data->buf_len) < 0) {
-    req_data->error = kI2cErrWrite;
-  }
-
-  if (req_data->buf_data != NULL) {
-    iotjs_buffer_release(req_data->buf_data);
-  }
-}
-
-void ReadWorker(uv_work_t* work_req) {
-  I2C_WORKER_INIT_TEMPLATE;
-  iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
-  IOTJS_I2C_METHOD_HEADER(i2c);
-
-  uint8_t len = req_data->buf_len;
-  req_data->buf_data = iotjs_buffer_allocate(len);
-
-  req_data->error = kI2cErrOk;
-  if (peripheral_i2c_read(platform_data->handle,
-                          (unsigned char*)req_data->buf_data,
-                          req_data->buf_len) < 0) {
-    req_data->error = kI2cErrWrite;
-  }
-}
diff --git a/src/modules/tizenrt/iotjs_module_i2c-tizenrt.c b/src/modules/tizenrt/iotjs_module_i2c-tizenrt.c
index 626c94c41..4ef0605f8 100644
--- a/src/modules/tizenrt/iotjs_module_i2c-tizenrt.c
+++ b/src/modules/tizenrt/iotjs_module_i2c-tizenrt.c
@@ -34,122 +34,118 @@ struct iotjs_i2c_platform_data_s {
 };
 
 
-void i2c_create_platform_data(void* device, iotjs_i2c_t* i2c,
-                              iotjs_i2c_platform_data_t** ppdata) {
-  iotjs_i2c_platform_data_t* pdata = IOTJS_ALLOC(iotjs_i2c_platform_data_t);
+void i2c_create_platform_data(iotjs_i2c_t* i2c) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
+
+  _this->platform_data = IOTJS_ALLOC(iotjs_i2c_platform_data_t);
 
-  pdata->bus = *(int*)device;
-  pdata->i2c_context = NULL;
-  *ppdata = pdata;
+  _this->platform_data->i2c_context = NULL;
 }
 
 
-void i2c_destroy_platform_data(iotjs_i2c_platform_data_t* pdata) {
-  IOTJS_ASSERT(pdata);
-  IOTJS_RELEASE(pdata);
+void i2c_destroy_platform_data(iotjs_i2c_platform_data_t* platform_data) {
+  IOTJS_ASSERT(platform_data);
+  IOTJS_RELEASE(platform_data);
 }
 
 
-#define I2C_WORKER_INIT_TEMPLATE                                            \
-  iotjs_i2c_reqwrap_t* req_wrap = iotjs_i2c_reqwrap_from_request(work_req); \
-  iotjs_i2c_reqdata_t* req_data = iotjs_i2c_reqwrap_data(req_wrap);
+jerry_value_t iotjs_i2c_set_platform_config(iotjs_i2c_t* i2c,
+                                            const jerry_value_t jconfig) {
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
+  iotjs_i2c_platform_data_t* platform_data = _this->platform_data;
 
+  DJS_GET_REQUIRED_CONF_VALUE(jconfig, platform_data->bus,
+                              IOTJS_MAGIC_STRING_BUS, number);
 
-void I2cSetAddress(iotjs_i2c_t* i2c, uint8_t address) {
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c)
-  iotjs_i2c_platform_data_t* pdata = _this->platform_data;
-  IOTJS_ASSERT(pdata);
-  IOTJS_ASSERT(pdata->i2c_context);
+  return jerry_create_undefined();
+}
 
-  if (iotbus_i2c_set_address(pdata->i2c_context, address) < 0) {
-    DLOG("%s: cannot set address", __func__);
-    IOTJS_ASSERT(0);
+
+#define I2C_METHOD_HEADER(arg)                                     \
+  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, arg)                  \
+  iotjs_i2c_platform_data_t* platform_data = _this->platform_data; \
+  IOTJS_ASSERT(platform_data);                                     \
+  if (!platform_data->i2c_context) {                               \
+    DLOG("%s: I2C is not opened", __func__);                       \
+    return false;                                                  \
   }
-}
 
 
-void OpenWorker(uv_work_t* work_req) {
-  I2C_WORKER_INIT_TEMPLATE;
-  iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
+bool iotjs_i2c_open(iotjs_i2c_t* i2c) {
   IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c)
-  iotjs_i2c_platform_data_t* pdata = _this->platform_data;
-
-  IOTJS_ASSERT(pdata);
+  iotjs_i2c_platform_data_t* platform_data = _this->platform_data;
+  IOTJS_ASSERT(platform_data);
 
   // Init i2c context
-  pdata->i2c_context = iotbus_i2c_init(pdata->bus);
-  if (!pdata->i2c_context) {
+  platform_data->i2c_context = iotbus_i2c_init(platform_data->bus);
+  if (!platform_data->i2c_context) {
     DLOG("%s: cannot open I2C", __func__);
-    req_data->error = kI2cErrOpen;
-    return;
+    return false;
   }
 
   // Set i2c frequency
-  int ret = iotbus_i2c_set_frequency(pdata->i2c_context, IOTBUS_I2C_STD);
+  int ret =
+      iotbus_i2c_set_frequency(platform_data->i2c_context, IOTBUS_I2C_STD);
   if (ret < 0) {
     DLOG("%s: cannot set frequency", __func__);
-    req_data->error = kI2cErrOpen;
-    return;
+    return false;
+  }
+
+  if (iotbus_i2c_set_address(platform_data->i2c_context, _this->address) < 0) {
+    DLOG("%s: cannot set address", __func__);
+    return false;
   }
 
-  req_data->error = kI2cErrOk;
+  return true;
 }
 
 
-void I2cClose(iotjs_i2c_t* i2c) {
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c);
-  iotjs_i2c_platform_data_t* pdata = _this->platform_data;
+bool iotjs_i2c_close(iotjs_i2c_t* i2c) {
+  I2C_METHOD_HEADER(i2c);
 
-  if (iotbus_i2c_stop(pdata->i2c_context) < 0) {
+  if (iotbus_i2c_stop(platform_data->i2c_context) < 0) {
     DLOG("%s: cannot close I2C", __func__);
-    IOTJS_ASSERT(0);
+    return false;
   }
-}
 
+  return true;
+}
 
-void WriteWorker(uv_work_t* work_req) {
-  I2C_WORKER_INIT_TEMPLATE;
-  iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c)
-  iotjs_i2c_platform_data_t* pdata = _this->platform_data;
 
-  uint8_t len = req_data->buf_len;
-  uint8_t* data = (uint8_t*)req_data->buf_data;
+bool iotjs_i2c_write(iotjs_i2c_t* i2c) {
+  I2C_METHOD_HEADER(i2c);
 
-  IOTJS_ASSERT(pdata);
-  IOTJS_ASSERT(pdata->i2c_context);
+  uint8_t len = _this->buf_len;
   IOTJS_ASSERT(len > 0);
+  uint8_t* data = (uint8_t*)_this->buf_data;
 
-  if (iotbus_i2c_write(pdata->i2c_context, data, len) < 0) {
-    DLOG("%s: cannot write data", __func__);
-    req_data->error = kI2cErrWrite;
-  } else {
-    req_data->error = kI2cErrOk;
+  int ret = iotbus_i2c_write(platform_data->i2c_context, data, len);
+
+  if (_this->buf_data != NULL) {
+    iotjs_buffer_release(_this->buf_data);
   }
 
-  iotjs_buffer_release(req_data->buf_data);
+  if (ret < 0) {
+    DLOG("%s: cannot write data", __func__);
+    return false;
+  }
+  return true;
 }
 
 
-void ReadWorker(uv_work_t* work_req) {
-  I2C_WORKER_INIT_TEMPLATE;
-  iotjs_i2c_t* i2c = iotjs_i2c_instance_from_reqwrap(req_wrap);
-  IOTJS_VALIDATED_STRUCT_METHOD(iotjs_i2c_t, i2c)
-  iotjs_i2c_platform_data_t* pdata = _this->platform_data;
+bool iotjs_i2c_read(iotjs_i2c_t* i2c) {
+  I2C_METHOD_HEADER(i2c);
 
-  uint8_t len = req_data->buf_len;
-  req_data->buf_data = iotjs_buffer_allocate(len);
+  uint8_t len = _this->buf_len;
+  _this->buf_data = iotjs_buffer_allocate(len);
 
-  IOTJS_ASSERT(pdata);
-  IOTJS_ASSERT(pdata->i2c_context);
   IOTJS_ASSERT(len > 0);
 
-  if (iotbus_i2c_read(pdata->i2c_context, (uint8_t*)req_data->buf_data, len) <
-      0) {
+  if (iotbus_i2c_read(platform_data->i2c_context, (uint8_t*)_this->buf_data,
+                      len) < 0) {
     DLOG("%s: cannot read data", __func__);
-    req_data->error = kI2cErrRead;
-    return;
+    return false;
   }
 
-  req_data->error = kI2cErrOk;
+  return true;
 }
diff --git a/test/run_pass/test_i2c.js b/test/run_pass/test_i2c.js
deleted file mode 100644
index ce1cb2028..000000000
--- a/test/run_pass/test_i2c.js
+++ /dev/null
@@ -1,46 +0,0 @@
-/* Copyright 2016-present Samsung Electronics Co., Ltd. and other contributors
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-/* This test is based on Raspberry Pi with GY-30 Sensor. */
-
-var assert = require('assert');
-var pin = require('tools/systemio_common').pin;
-var checkError = require('tools/systemio_common').checkError;
-var I2C = require('i2c');
-
-var i2c = new I2C();
-var configuration = {
-  address: 0x23,
-  device: pin.i2c1, // for Linux, NuttX and Tizen
-  bus: pin.i2c1 // for TizenRT
-};
-
-var wire = i2c.open(configuration, function(err) {
-  checkError(err);
-
-  wire.write([0x10], function(err) {
-    checkError(err);
-    console.log('write done');
-
-    wire.read(2, function(err, res) {
-      checkError(err);
-      assert.equal(res.length, 2, 'I2C read failed.(length is not equal)');
-      console.log('read result: '+res[0]+', '+res[1]);
-      wire.close();
-      console.log('test ok');
-    });
-  });
-});
-
diff --git a/test/run_pass/test_i2c_gy30.js b/test/run_pass/test_i2c_gy30.js
new file mode 100644
index 000000000..f942b1668
--- /dev/null
+++ b/test/run_pass/test_i2c_gy30.js
@@ -0,0 +1,83 @@
+/* Copyright 2016-present Samsung Electronics Co., Ltd. and other contributors
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+
+/* This should be tested with GY-30 Sensor.
+  *
+  * The following is pin information.
+  * Linux(Raspberry PI2): BCM2(SDA), BCM3(SCL)
+  * NuttX(STM32F4-Discovery): PB7(SDA), PB8(SCL)
+  * TizenRT(Artik053): CON703(10)(SDA), CON703(8)(SCL) - XI2C1
+  *
+*/
+
+var assert = require('assert');
+var pin = require('tools/systemio_common').pin;
+var checkError = require('tools/systemio_common').checkError;
+var i2c = require('i2c');
+
+var configuration = {
+  address: 0x23,
+  device: pin.i2c1, // for Linux
+  bus: pin.i2c1, // for TizenRT and NuttX
+};
+
+syncTest();
+
+function syncTest() {
+  console.log('I2C sync function test');
+
+  var wire = i2c.openSync(configuration);
+  var loopCnt = 5;
+
+  var loop = setInterval(function() {
+    wire.writeSync([0x10]);
+    var res = wire.readSync(2);
+    console.log('read result', (res[1] + (256 * res[0])));
+
+    if (--loopCnt <= 0) {
+      clearInterval(loop);
+      wire.closeSync();
+      asyncTest();
+    }
+  }, 800);
+}
+
+function asyncTest() {
+  console.log('I2C async function test');
+
+  i2c.open(configuration, function(err, wire) {
+    checkError(err);
+    var loopCnt = 5;
+
+    var loop = setInterval(function() {
+      wire.write([0x10], function(err) {
+        checkError(err);
+
+        wire.read(2, function(err, res) {
+          checkError(err);
+          assert.equal(res.length, 2, 'I2C read failed.(length is not equal)');
+
+          console.log('read result: ', (res[1] + (256 * res[0])));
+
+          if (--loopCnt <= 0) {
+            clearInterval(loop);
+            wire.close();
+          }
+        });
+      });
+    }, 800);
+  });
+}
diff --git a/test/testsets.json b/test/testsets.json
index 581e58352..fef1256a5 100644
--- a/test/testsets.json
+++ b/test/testsets.json
@@ -45,7 +45,7 @@
     { "name": "test_fs_open_read_sync_3.js" },
     { "name": "test_gpio_input.js", "skip": ["all"], "reason": "needs hardware" },
     { "name": "test_gpio_output.js", "skip": ["all"], "reason": "need user input"},
-    { "name": "test_i2c.js", "skip": ["all"], "reason": "need to setup test environment" },
+    { "name": "test_i2c_gy30.js", "skip": ["all"], "reason": "need to setup test environment" },
     { "name": "test_iotjs_promise.js", "skip": ["all"], "reason": "es2015 is off by default" },
     { "name": "test_iotjs_promise_chain_calls.js", "skip": ["all"], "reason": "es2015 is off by default" },
     { "name": "test_module_cache.js", "skip": ["nuttx"], "reason": "not implemented for nuttx" },
diff --git a/test/tools/systemio_common.js b/test/tools/systemio_common.js
index 0dea26f9e..74ad6177e 100644
--- a/test/tools/systemio_common.js
+++ b/test/tools/systemio_common.js
@@ -23,10 +23,10 @@ if (process.platform === 'linux') {
 } else if (process.platform === 'nuttx') {
   var stm32_pin = require('stm32f4dis').pin;
   pin.pwm1 = stm32_pin.PWM1.CH1_1;
-  pin.i2c1 = 0;
+  pin.i2c1 = 1;
 } else if (process.platform === 'tizenrt') {
   pin.pwm1 = 0;
-  pin.i2c1 = 0;
+  pin.i2c1 = 1;
 } else {
   throw new Error('Unsupported platform');
 }
